mod first;
mod second;

fn main() {
    let raw = std::fs::read_to_string("input.txt").expect("Couldn't read input");
    let first = first::parse(&raw);
    println!("{}", first);
    let second: u32 = second::parse(&raw)
        .iter()
        .scan(true, |p, i| match i {
            second::Item::Do => {
                *p = true;
                Some(None)
            }
            second::Item::Dont => {
                *p = false;
                Some(None)
            }
            second::Item::Mul(n) => {
                if *p {
                    Some(Some(n))
                } else {
                    Some(None)
                }
            }
        })
        .flatten()
        .sum();
    println!("{}", second);
}
